@if "%debug%"=="" echo off
if "%1"==":" if not "%2"=="" goto %2

if "%2"=="" goto _help 

echo.
echo UBCD2USB: Creating bootable USB drive from UBCD 

if not exist ldlinux.bss     %0 : _error Missing file 'ldlinux.bss' 
if not exist ldlinux.sys     %0 : _error Missing file 'ldlinux.sys'
if not exist mbr.bin         %0 : _error Missing file 'mbr.bin'
if not exist makebootfat.exe %0 : _error Missing file 'makebootfat.exe'
if not exist wait.com        %0 : _error Missing file 'wait.com'
if not exist ubcdroot\nul    %0 : _error Missing dir 'ubcdroot'

:_mkbtft
if "%3"=="-y" goto _gomkbt
if "%3"=="-Y" goto _gomkbt
echo UBCD2USB: YOUR USB KEY IS ABOUT TO BE REFORMATTED
wait press any key to continue, press ESC to abort
if errorlevel 27 if not errorlevel 28 goto _skip
echo UBCD2USB: YOUR USB KEY CONTENTS WILL BE LOST
wait press any key to continue, press ESC to abort
if errorlevel 27 if not errorlevel 28 goto _skip
:_gomkbt
echo UBCD2USB: Launching 'makebootfat' to format USB drive
makebootfat -o usb -Z -Y -b ldlinux.bss -m mbr.bin -c ldlinux.sys ubcdroot
if errorlevel 1 %0 : _error 'makebootfat.exe' failed
if errorlevel 0 goto _xcpy 
%0 : _error 'makebootfat.exe' failed

:_xcpy
wait 3
if not exist %1\ubcd\ubcd.css %0 : _error Missing '%1\ubcd\ubcd.css' (where is UBCD?)
if not exist %2\ldlinux.sys   %0 : _error Missing '%2\ldlinux.sys' (where is USB-drive?)
:_xcpy1
echo UBCD2USB: Transfering UBCD-base (%1) to USB drive (%2)
if not exist excl_dir.lst %0 : _error Missing file 'excl_dir.lst'
xcopy %1\*.* %2\. /D /E /I /H /R /Y /Q /EXCLUDE:excl_dir.lst
for %%i in (%2\boot.catalog %2\autorun.inf %2\ubcd.ico) do del %%i >nul
:_xcpy2
echo UBCD2USB: Transfering UBCD-images (%1\images) to USB drive (%2)
if not exist excl_img.lst %0 : _error Missing file 'excl_img.lst' 
xcopy %1\images\*.* %2\. /D /E /I /H /R /Y /Q /EXCLUDE:excl_img.lst
echo UBCD2USB: Checking for '%2\freedos.img'
if exist %2\fdubcd.img if exist %2\freedos.img del %2\freedos.img >nul
if exist %2\fdubcd.img copy %2\fdubcd.img %2\freedos.img >nul
if not exist %2\freedos.img %0 : _error Missing file '%2\freedos.img' 
echo UBCD2USB: Bootable USB version of UBCD ready
echo.
wait 3
if not "%3"=="-Y" if not "%3"=="-y" pause
goto _end

:_help
echo.
echo UBCD2USB: Create bootable USB key from UBCD a la Reblu
echo.
echo Usage:    UBCD2USB [UBCD-path] [USB-drive:] [params]
echo.          
echo Params:   -Y       No Format-warning, no pause (for batch-mode)
echo.
echo Example:  UBCD2USB e: f: -y
echo           (UBCD-CDROM in 'E:', USB-key in 'F:', no warning)
echo.
echo           UBCD2USB d:\ubcd f:
echo           (UBCD extracted in dir 'D:\ubcd', USB-key in 'F:')
echo.
echo. 
echo Required: XP or W2K or W2K3 and an (optionally extracted) UBCD
echo.
pause
goto _end

:_error
shift
shift
echo.
echo (ERROR) %1 %2 %3 %4 %5 %6 %7 %8
echo.
pause
goto _end

:_skip
echo UBCD2USB: (bailed out) USB drive untouched
wait 5
:_end
echo.
